OpenSSL::SSL::Server - Crystal 1.20.1

# class OpenSSL::SSL::Server

- OpenSSL::SSL::Server
- Reference
- Object

##
Overview

This class wraps another `::Socket::Server` in an SSL layer.

    require "socket"
    require "openssl"

    tcp_server = TCPServer.new(0)

    ssl_context = OpenSSL::SSL::Context::Server.new
    ssl_context.certificate_chain = "openssl.crt"
    ssl_context.private_key = "openssl.key"
    ssl_server = OpenSSL::SSL::Server.new(tcp_server, ssl_context)

    puts "SSL Server listening on #{tcp_server.local_address}"
    while connection = ssl_server.accept?
      connection.puts "secure message"
      connection.close
    end

##
Included Modules

- Socket::Server

##
Defined in:

openssl/ssl/server.cr

##
Constructors

- .new(wrapped : ::Socket::Server, context : OpenSSL::SSL::Context::Server = OpenSSL::SSL::Context::Server.new, sync_close : Bool = true)

  Creates a new SSL server wrapping wrapped.

##
Class Method Summary

- .open(wrapped : ::Socket::Server, context : OpenSSL::SSL::Context::Server = OpenSSL::SSL::Context::Server.new, sync_close : Bool = true, &)

  Creates a new SSL server wrapping wrapped and yields it to the block.

##
Instance Method Summary

- #accept : OpenSSL::SSL::Socket::Server

  Implements `::Socket::Server#accept`.

- #accept? : OpenSSL::SSL::Socket::Server | Nil

  Implements `::Socket::Server#accept?`.

- #close : Nil

  Closes this SSL server.

- #closed? : Bool

  Returns `true` if this SSL server has been closed.

- #context : OpenSSL::SSL::Context::Server

  Returns the SSL context.

- #local_address : ::Socket::Address

  Returns local address of `#wrapped`.

- #start_immediately : Bool

  When `true` a call to `#accept` will also initiate the SSL handshake.

- #start_immediately=(start_immediately : Bool)

  When `true` a call to `#accept` will also initiate the SSL handshake.

- #sync_close=(sync_close : Bool)

  If `#sync_close?` is `true`, closing this server will close the wrapped server.

- #sync_close? : Bool

  If `#sync_close?` is `true`, closing this server will close the wrapped server.

- #wrapped : ::Socket::Server

  Returns the wrapped server socket.

### Instance methods inherited from module `Socket::Server`

accept : IO
accept(&) accept, accept? : IO | Nil
accept?(&) accept?

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(wrapped : ::Socket::Server, context : OpenSSL::SSL::Context::Server = OpenSSL::SSL::Context::Server.new, sync_close : Bool = true) #

Creates a new SSL server wrapping wrapped.

context configures the SSL options, see `OpenSSL::SSL::Context::Server` for details

##
Class Method Detail

def self.open(wrapped : ::Socket::Server, context : OpenSSL::SSL::Context::Server = OpenSSL::SSL::Context::Server.new, sync_close : Bool = true, &) #

Creates a new SSL server wrapping wrapped and yields it to the block.

context configures the SSL options, see `OpenSSL::SSL::Context::Server` for details

The server is closed after the block returns.

##
Instance Method Detail

def accept : OpenSSL::SSL::Socket::Server #

Implements `::Socket::Server#accept`.

This method calls `@wrapped.accept` and wraps the resulting IO in a SSL socket (`OpenSSL::SSL::Socket::Server`) with `#context` configuration.

def accept? : OpenSSL::SSL::Socket::Server | Nil #

Implements `::Socket::Server#accept?`.

This method calls `@wrapped.accept?` and wraps the resulting IO in a SSL socket (`OpenSSL::SSL::Socket::Server`) with `#context` configuration.

def close : Nil #

Closes this SSL server.

Propagates to `#wrapped` if `sync_close` is `true`.

def closed? : Bool #

Returns `true` if this SSL server has been closed.

def context : OpenSSL::SSL::Context::Server #

Returns the SSL context.

def local_address : ::Socket::Address #

Returns local address of `#wrapped`.

def start_immediately : Bool #

When `true` a call to `#accept` will also initiate the SSL handshake.

def start_immediately=(start_immediately : Bool) #

When `true` a call to `#accept` will also initiate the SSL handshake.

def sync_close=(sync_close : Bool) #

If `#sync_close?` is `true`, closing this server will close the wrapped server.

def sync_close? : Bool #

If `#sync_close?` is `true`, closing this server will close the wrapped server.

def wrapped : ::Socket::Server #

Returns the wrapped server socket.